Bug 62206 - linuxrc script in initrd image doesn't work for root on DAC960
linuxrc script in initrd image doesn't work for root on DAC960
Product: Red Hat Public Beta
Classification: Retired
Component: mkinitrd (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Matt Wilson
David Lawrence
: 60147 62336 (view as bug list)
Depends On:
Blocks: 61590
  Show dependency treegraph
Reported: 2002-03-28 09:03 EST by Gert Dewit
Modified: 2007-04-18 12:41 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-05-13 05:44:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
mknod feedback patch (502 bytes, patch)
2002-03-29 06:15 EST, Gert Dewit
no flags Details | Diff

  None (edit)
Description Gert Dewit 2002-03-28 09:03:17 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 Galeon/1.0.3 (X11; Linux i686; U;) Gecko/20020205

Description of problem:
the linuxrc script that gets generated by mkinitrd uses LABEL for root disk ->
mount of root fails -> no init found message.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1.install with root on DAC960 volume

Actual Results:  3.no init found

Expected Results:  boot fresh installation

Additional info:

I can work around the problem by adding the device nodes for the DAC960 volumes
to the dev directory of the initrd image and specifying the root partition's
/dev/rd/c?d?p? on the mount line in linuxrc.

$ ls -l /mnt/loop/dev
brw-rw----    1 root     disk      48,   0 Mar 28 14:11 c0d0
brw-rw----    1 root     disk      48,   1 Mar 28 14:10 c0d0p1
brw-rw----    1 root     disk      48,   2 Mar 28 14:10 c0d0p2
brw-rw----    1 root     disk      48,   3 Mar 28 14:10 c0d0p3
brw-rw----    1 root     disk      48,   4 Mar 28 14:10 c0d0p4
brw-rw----    1 root     disk      48,   5 Mar 28 14:10 c0d0p5
brw-rw----    1 root     disk      48,   6 Mar 28 14:10 c0d0p6
brw-rw----    1 root     disk      48,   7 Mar 28 14:10 c0d0p7

example linuxrc: 

echo "Loading scsi_mod module"
insmod /lib/scsi_mod.o
echo "Loading sd_mod module"
insmod /lib/sd_mod.o
echo "Loading aic7xxx module"
insmod /lib/aic7xxx.o
echo "Loading DAC960 module"
insmod /lib/DAC960.o
echo "Loading jbd module"
insmod /lib/jbd.o
echo "Loading ext3 module"
insmod /lib/ext3.o
echo Mounting /proc filesystem
mount -t proc /proc /proc
echo 0x0100 > /proc/sys/kernel/real-root-dev
echo Mounting root filesystem
mount --ro -t ext3 /dev/rd/c0d0p2 /sysroot
umount /proc
pivot_root /sysroot /sysroot/initrd
Comment 1 Bill Nottingham 2002-03-28 16:47:07 EST
Jeremy, is this fixed in the new mkinitrd?
Comment 2 Jeremy Katz 2002-03-28 16:56:39 EST
Yeah, fixing cciss should have fixed DAC960 as well
Comment 3 Gert Dewit 2002-03-29 06:15:52 EST
Created attachment 51344 [details]
mknod feedback patch
Comment 4 Gert Dewit 2002-03-29 06:17:29 EST
I've used nash from mkinitrd 3.3.6 and it seems to work.

Maybe it would be a good idea to check to return value of mknod
in the uuidcache_init function of mount_by_label.c and provide some
feedback as this would make diagnosing the problem more easy. I've attached a 
patch for this.

Something that could (should) be fixed in a later version is the hardcoded 1 
subdirectory of /dev detection. The way it's implemented today only devices
1 level deep in /dev will work. If someting like /devices/block would be used 
instead of /dev this code will fail. I suppose this could be a future problem 
with devfs.
Comment 5 Matt Wilson 2002-04-01 11:07:17 EST
*** Bug 62336 has been marked as a duplicate of this bug. ***
Comment 6 Matt Wilson 2002-04-01 11:08:04 EST
*** Bug 60147 has been marked as a duplicate of this bug. ***
Comment 7 Need Real Name 2002-04-02 15:26:42 EST
I opened what was deemed as a duplicated bug,  62336, but I don't understand the
solution based on the comments here.  I want the system to boot properly after
the install without having to make modifications-- am I going to have to wait
for a later beta release?


Comment 8 Patrick C. F. Ernzer 2002-05-13 05:44:42 EDT
This does not seem to be fixed in RHL 7.3 (which includes mkinitrd-3.3.10-1),
c.f. bug 64736
Comment 9 Jeremy Katz 2002-05-13 11:29:48 EDT
Symptom is the same.  Root problem is unrelated.  We're not mounting by label in
the initrd anymore, so this bug doesn't apply.  Reclosing

Note You need to log in before you can comment on or make changes to this bug.